<script setup>
import {useRoute} from "vue-router"
import {computed, ref, watch} from "vue"
import {useStudentStore} from "@/stores/student"
import Sidebar from "@/components/Sidebar.vue"
import {router} from "@/router";
import {useGroupStore} from "@/stores/group";
import {useEnumStore} from "@/stores/enumStore";

const route = useRoute()
const studentStore = useStudentStore()
const groupStore = useGroupStore()
const enumStore = useEnumStore()
const studentIndex = computed(() => parseInt(route.params.studentIndex))

const studentget = computed(() => studentStore.students[studentIndex.value])

const student = ref()

const studentFirstName = ref("")
const studentLastName = ref("")
const studentEmail = ref("")
const studentSpecializations = ref("")
const groupId = ref()
const apiError = ref("")
const edit = ref(false)

watch(studentget, () => student.value = ({...studentget.value} || {firstName: ""}), {immediate: true})

async function deleteStudent() {
  const response = await useStudentStore().deleteStudent(student.value);

  await router.push("/student")
  console.log("test");
}

async function updateStudent() {

  apiError.value = ""

  try {
    await studentStore.updateStudent({
      firstName: student.value.firstName,
      lastName: student.value.lastName,
      email: student.value.email,
      specializations: student.value.specializations,
      groupId: student.value.groupId

    })

  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }
  await router.push("/student")
}

studentSpecializations.value = ""
studentFirstName.value = ""
studentLastName.value = ""
studentEmail.value = ""
groupId.value = null

</script>

<template>
  <Sidebar></Sidebar>

  <h1>Details for Students</h1>

  <div class="container text-white rounded-2 p-3 mb-3">
    <p>First Name: <span v-if="!edit">{{ student.firstName }}</span> <input v-else type="text" class="form-control"
                                                                            v-model="student.firstName"/></p>
    <p>Last Name: <span v-if="!edit">{{ student.lastName }}</span> <input v-else type="text" class="form-control"
                                                                          v-model="student.lastName"/></p>
    <p>Email: <span v-if="!edit">{{ student.email }}</span> <input v-else type="text" class="form-control"
                                                                   v-model="student.email"/></p>
    <p>Group: </p>
    <p v-if="!edit">{{ groupStore.groups.find(group => group.groupId === student.groupId)?.specializations }}
      {{ groupStore.groups.find(group => group.groupId === student.groupId)?.groupNumber }}</p>
    <select v-else class="form-select" name="groupId" v-model="student.groupId">
      <option v-for="group in groupStore.groups" :value="group.groupId">{{ group.specializations }}
        {{ group.groupNumber }}
      </option>
    </select>
  </div>

  <div class="buttons">
    <v-btn type="submit" class="btn btn-warning mx-2" @click="edit = !edit" v-if="!edit">Edit</v-btn>
    <v-btn type="submit" class="btn btn-warning mx-2" @click="updateStudent" v-else>Save</v-btn>
    <v-btn type="submit" class="btn btn-danger" @click="deleteStudent">Delete</v-btn>
  </div>

</template>


<style scoped>
h1 {
  margin-left: 0px;
  margin-bottom: 20px;
  margin-top: 0px;
}

p {
  margin-left: 0px;
}

.form-check {
  margin-left: 0px;
}

.container {
  background-color: black;
  width: 1000px;
}

.buttons {
  margin-left: 0px;
  margin-top: 15px;
  margin-bottom: 20px;

}
</style>